/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |   hlavickovy subor pre chybove  | */
/* | Jozef  Henzl             | xhenzl04  |   hlasenia                      | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */
                                                                 

// TOTO JE LEN AKO KEBY HLAVICKA NIC TU NENI TREBA PREPISAT DOPISAT ,JETO LEN ZATIAL
#ifndef _ERROR_H_
#define _ERROR_H_


#ifdef  __cplusplus
extern "C" {
#endif

#include "parser.h"

/**chybove hlasenia vracajuce celkovy vysledok programu vid zadanie,.. ako aj chyby pri jednotlivych funkciach a moduloch */
typedef enum {
  
  EOK,           //0- setko ok
  ERR_LEX,       //1- chyba v lexikalnej analyze
  ERR_SYNTAX,    //2- syntaktickej
  ERR_SEMANTIC,  //3- semantickej
  ERR_INTERPRET, //4- chyba v interpretacii konkretnych dat,chybne hodnoty na vstupe a podobne
  ERR_DATA,      //5- chyba mimo interpretu ,nedostatok pamete,chybne otvorenie suboru a podobne
  ERR_FOPEN,     // tuna dOPLNIT nase errory ...
  ERR_MEMORY,

} errors;

void print_error(errors n);

/**
* vypise formatovanou log zpravu na stderr
* @param fmt formatovaci retezec
* @param ... argumenty
*/
void print_log(const char *fmt, ...);
void _print_debug(const char *fmt, ...);

#if DEBUG_ON
#define FMTSTRING " (%s@%s:%d)\n"
#define print_debug(args) {_print_debug("DEBUG: ");_print_debug args;_print_debug(FMTSTRING, __func__, __FILE__, __LINE__); }
#else
#define print_debug(args) {}
#endif

#endif /* __ERROR_H_ */
