/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |   modul knihovnylexikalnej      | */
/* | Jozef  Henzl             | xhenzl04  |         analyzi                 | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>


/**nespravny lexem ,ked lexikalna analyza vrati z funkcie getToken pre syntakticku WRONG_LEXEM,nastavujeme a vraciame vyslednu chybu v lexikalnej analyze */
#define WRONG_LEXEM -1

/**klucove slova */
#define BEGIN 100
#define DIV 101
#define DO 102
#define DOUBLE 103
#define ELSE 104
#define END 105
#define FIND 106
#define IF 107
#define INTEGER 108
#define READLN 109
#define SORT 110
#define STRING 111
#define THEN 112
#define VAR 113
#define WHILE 114
#define WRITE 115
#define REPEAT 116
#define UNTIL 117

// + 10
// - 11
// * 12
// ( 13 
// ) 14
// [ 15
// ] 16
// ; 17
// , 18
// = 19
/**zakladne lexemy */
#define DOT_TOKEN 9
#define PLUS_TOKEN 10
#define MINUS_TOKEN 11
#define MULT_TOKEN 12
#define LEFT_BRACKET 13
#define RIGHT_BRACKET 14
#define SEMICOLON 15
#define COMMA 16
#define EKVIVALENCE 17

/**tu budu zlozitejsie znaky ktore vyzaduju prechod do viacerych stavov*/
// : 20
// := 21
// < 22
// <= 23
// <> 24
// > 25
// >= 26
// identifikator 27
#define COLON 20
#define ASSIGNING 21
#define LESS_TOKEN 22
#define LESS_EQUAL 23
#define UN_EQUAL 24
#define GREATER_TOKEN 25
#define GREATER_EQUAL 26
#define ID 27

/**ciselne konstanty */
//double vraciame bud klasicke double cislo ako napr 12.987 alebo double s exponentom 12.3e21,12e3421,33.2e+2,1.2e-2 
//znamienko je nepovinne
#define INT_CONST 50
#define DOUBLE_DOT 51
#define DOUBLE_EXP 52 

//koniec suboru
#define END_OF_FILE 300

/**globalna premenna pre jednoduchsiu pracu zo vstupnym suborom */
FILE *source;

/**prototyp funkcie pre otvorenie a zatvorenie suboru 
@param path cesta k suboru
@return RUN_ERROR pri chybnom otvoreni ,0 pri uspesnom otvoreni*/
int ReadFile(char *path) ;

/**funkcia pre zatvorenie suboru*/
void CloseFile(void);

/**pri retazcoch mame escape sekvencie '#i'kde i patri do intervalu cisel <1,31>,preto robime kontrolu ci su cisla naozaj z tochto intervalu
@param buff cislo ktore kontrolujeme
@return 0 - uspech || 1 - neuspech  */
int numb_control(int buff);

/**PROTOTYP HLAVNEJ FUNKCIE KTORU VOLA PARSER 
funkcia ktoru vola syntakticky analyzator ,funkcia vracia cislo ktore reprezentuje nadefinovany dany symbol,v parametri funkcie ,v bufferi vracia dany atribut / hodnotu symbolu ... napriklad ak nacitame identifikator ,funkcia vrati ze sa jedna o identifikator a v bufferi posle jeho nazov
@param buffer buffer v ktorom funckia vrati atribut daneho tokenu ktory ho reprezentuje 
@return TYP TOKENU */
int getNextToken(string_t *buffer);

/**
@return lineno - vrati riadok na ktorom sa nachadzame*/
int getCurLine(void);


