/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |  Modul obsahujuci funkcie       | */
/* | Jozef  Henzl             | xhenzl04  |  zasobniku                      | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */
                                                                 
#include <stdlib.h>
#include <stdio.h> 
//#include "scanner.h"
#include "hash.h"
//#include "error.h"

#define TRUE 1
#define FALSE 0

 

//  element na zasobniku
typedef struct stack_element
{
  htable_item *htiptr;
	int token;
  struct stack_element *next;
} *stack_elem_ptr_t;

//  zasobnik
typedef struct stack
{
  stack_elem_ptr_t act;
	stack_elem_ptr_t top;
} stack_t;

//prototypy funkcii
void stackInit(stack_t *zasobnik);
void stackDispose(stack_t *zasobnik);
int stackEmpty(stack_t *zasobnik);
int stackTopPop(stack_t *zasobnik, htable_item **htiptr);
int stackGetActSucc(stack_t *zasobnik);
void stackPush(stack_t *zasobnik, int symbol, htable_item *htiptr);

