/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |      knihovna ktora pracuje     | */
/* | Jozef  Henzl             | xhenzl04  |        s retazcami              | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */
                                                                 
#ifndef _STR_H_
#define _STR_H_
                                                      

#ifdef  __cplusplus
extern "C" {
#endif

#define STR_ERROR   1
#define STR_SUCCESS 0

//hlavickovy soubor pro praci s nekonecne dlouhymi retezci

typedef struct
{
  char* str;		// misto pro dany retezec ukonceny znakem '\0'
  int length;		// skutecna delka retezce
  int allocSize;	// velikost alokovane pameti
} string_t, string;


int strInit(string_t *s);
void strFree(string_t *s);

void strClear(string_t *s);
int strAddChar(string_t *s1, char c);
int strCmpString(string_t *s1, string_t *s2);
int strCmpConstStr(string_t *s1, char *s2);
int strConcat(string_t *s1, char *cs);
int strDup(string_t *dst, string_t *src);
int strCmp(string_t *s1, string_t *s2);

/* hledani podretezce v retezci */
int find(char *str, char *tok);

/* setrideni retezce podle ordinalni hodnoty znaku */
int sort(char *str);

#ifdef __cplusplus
}
#endif

#endif /* _STR_H_ */
